SourceTemplate< T > Class Template Reference

Transform a Store into a Source. More...

Inheritance diagram for SourceTemplate< T >:

## Public Member Functions

| SourceTemplate (BufferedTransformation *attachment)
| Construct a SourceTemplate. More...
void | IsolatedInitialize (const NameValuePairs &parameters)
| Initialize or reinitialize this object, without signal propagation. More...
size_t | Pump2 (lword &byteCount, bool blocking=true)
| Pump data to attached transformation. More...
size_t | PumpMessages2 (unsigned int &messageCount, bool blocking=true)
| Pump messages to attached transformation. More...
size_t | PumpAll2 (bool blocking=true)
| Pump all data to attached transformation. More...
bool | SourceExhausted () const
| Determines if the Source is exhausted. More...
void | SetAutoSignalPropagation (int propagation)
| Set propagation of automatically generated and transferred signals. More...
int | GetAutoSignalPropagation () const
| Retrieve automatic signal propagation value. More...
Public Member Functions inherited from Source
| Source (BufferedTransformation *attachment=NULL)
| Construct a Source. More...
lword | Pump (lword pumpMax=(size_t) ...)
| Pump data to attached transformation. More...
unsigned int | PumpMessages (unsigned int count=UINT_MAX)
| Pump messages to attached transformation. More...
void | PumpAll ()
| Pump all data to attached transformation. More...
Public Member Functions inherited from InputRejecting< Filter >
size_t | Put2 (const byte *inString, size_t length, int messageEnd, bool blocking)
| Input a byte array for processing. More...
bool | IsolatedFlush (bool hardFlush, bool blocking)
bool | IsolatedMessageSeriesEnd (bool blocking)
size_t | ChannelPut2 (const std::string &channel, const byte *inString, size_t length, int messageEnd, bool blocking)
bool | ChannelMessageSeriesEnd (const std::string &channel, int messageEnd, bool blocking)
Public Member Functions inherited from Filter
size_t | TransferTo2 (BufferedTransformation &target, lword &transferBytes, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer bytes from this object to another BufferedTransformation. More...
size_t | CopyRangeTo2 (BufferedTransformation &target, lword &begin, lword end=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true) const
| Copy bytes from this object to another BufferedTransformation. More...
void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| Initialize or reinitialize this object, with signal propagation. More...
bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| Flush buffered input and/or output, with signal propagation. More...
bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| Marks the end of a series of messages, with signal propagation. More...
| Filter (BufferedTransformation *attachment=NULL)
| Construct a Filter. More...
bool | Attachable ()
| Determine if attachable. More...
BufferedTransformation * | AttachedTransformation ()
| Retrieve attached transformation. More...
const BufferedTransformation * | AttachedTransformation () const
| Retrieve attached transformation. More...
void | Detach (BufferedTransformation *newAttachment=NULL)
| Replace an attached transformation. More...
Public Member Functions inherited from BufferedTransformation
| BufferedTransformation ()
| Construct a BufferedTransformation.
BufferedTransformation & | Ref ()
| Provides a reference to this object. More...
size_t | Put (byte inByte, bool blocking=true)
| Input a byte for processing. More...
size_t | Put (const byte *inString, size_t length, bool blocking=true)
| Input a byte buffer for processing. More...
size_t | PutWord16 (word16 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 16-bit word for processing. More...
size_t | PutWord32 (word32 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 32-bit word for processing. More...
virtual byte * | CreatePutSpace (size_t &size)
| Request space which can be written into by the caller. More...
virtual bool | CanModifyInput () const
| Determines whether input can be modifed by the callee. More...
size_t | PutModifiable (byte *inString, size_t length, bool blocking=true)
| Input multiple bytes that may be modified by callee. More...
bool | MessageEnd (int propagation=-1, bool blocking=true)
| Signals the end of messages to the object. More...
size_t | PutMessageEnd (const byte *inString, size_t length, int propagation=-1, bool blocking=true)
| Input multiple bytes for processing and signal the end of a message. More...
virtual size_t | PutModifiable2 (byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes that may be modified by callee. More...
unsigned int | GetMaxWaitObjectCount () const
| Retrieves the maximum number of waitable objects.
void | GetWaitObjects (WaitObjectContainer &container, CallStack const &callStack)
| Retrieves waitable objects. More...
virtual lword | MaxRetrievable () const
| Provides the number of bytes ready for retrieval. More...
virtual bool | AnyRetrievable () const
| Determines whether bytes are ready for retrieval. More...
virtual size_t | Get (byte &outByte)
| Retrieve a 8-bit byte. More...
virtual size_t | Get (byte *outString, size_t getMax)
| Retrieve a block of bytes. More...
virtual size_t | Peek (byte &outByte) const
| Peek a 8-bit byte. More...
virtual size_t | Peek (byte *outString, size_t peekMax) const
| Peek a block of bytes. More...
size_t | GetWord16 (word16 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| Retrieve a 16-bit word. More...
size_t | GetWord32 (word32 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| Retrieve a 32-bit word. More...
size_t | PeekWord16 (word16 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| Peek a 16-bit word. More...
size_t | PeekWord32 (word32 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| Peek a 32-bit word. More...
lword | TransferTo (BufferedTransformation &target, lword transferMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL)
| move transferMax bytes of the buffered output to target as input More...
virtual lword | Skip (lword skipMax=LWORD_MAX)
| Discard skipMax bytes from the output buffer. More...
lword | CopyTo (BufferedTransformation &target, lword copyMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| copy copyMax bytes of the buffered output to target as input More...
lword | CopyRangeTo (BufferedTransformation &target, lword position, lword copyMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| Copy bytes from this object using an index to another BufferedTransformation. More...
virtual lword | TotalBytesRetrievable () const
| Provides the number of bytes ready for retrieval. More...
virtual unsigned int | NumberOfMessages () const
| Provides the number of meesages processed by this object. More...
virtual bool | AnyMessages () const
| Determines if any messages are available for retrieval. More...
virtual bool | GetNextMessage ()
| Start retrieving the next message. More...
virtual unsigned int | SkipMessages (unsigned int count=UINT_MAX)
| Skip a number of meessages. More...
unsigned int | TransferMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=DEFAULT_CHANNEL)
| Transfer messages from this object to another BufferedTransformation. More...
unsigned int | CopyMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| Copy messages from this object to another BufferedTransformation. More...
virtual void | SkipAll ()
| Skip all messages in the series.
void | TransferAllTo (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL)
| Transfer all bytes from this object to another BufferedTransformation. More...
void | CopyAllTo (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL) const
| Copy messages from this object to another BufferedTransformation. More...
virtual bool | GetNextMessageSeries ()
| Retrieve the next message in a series. More...
virtual unsigned int | NumberOfMessagesInThisSeries () const
| Provides the number of messages in a series. More...
virtual unsigned int | NumberOfMessageSeries () const
| Provides the number of messages in a series. More...
size_t | TransferMessagesTo2 (BufferedTransformation &target, unsigned int &messageCount, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer messages from this object to another BufferedTransformation. More...
size_t | TransferAllTo2 (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer all bytes from this object to another BufferedTransformation. More...
size_t | ChannelPut (const std::string &channel, byte inByte, bool blocking=true)
| Input a byte for processing on a channel. More...
size_t | ChannelPut (const std::string &channel, const byte *inString, size_t length, bool blocking=true)
| Input a byte buffer for processing on a channel. More...
size_t | ChannelPutModifiable (const std::string &channel, byte *inString, size_t length, bool blocking=true)
| Input multiple bytes that may be modified by callee on a channel. More...
size_t | ChannelPutWord16 (const std::string &channel, word16 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 16-bit word for processing on a channel. More...
size_t | ChannelPutWord32 (const std::string &channel, word32 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 32-bit word for processing on a channel. More...
bool | ChannelMessageEnd (const std::string &channel, int propagation=-1, bool blocking=true)
| Signal the end of a message. More...
size_t | ChannelPutMessageEnd (const std::string &channel, const byte *inString, size_t length, int propagation=-1, bool blocking=true)
| Input multiple bytes for processing and signal the end of a message. More...
virtual byte * | ChannelCreatePutSpace (const std::string &channel, size_t &size)
| Request space which can be written into by the caller. More...
virtual size_t | ChannelPutModifiable2 (const std::string &channel, byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes that may be modified by callee on a channel. More...
virtual bool | ChannelFlush (const std::string &channel, bool hardFlush, int propagation=-1, bool blocking=true)
| Flush buffered input and/or output on a channel. More...
virtual void | SetRetrievalChannel (const std::string &channel)
| Sets the default retrieval channel. More...
virtual void | Attach (BufferedTransformation *newAttachment)
| Add newAttachment to the end of attachment chain. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...
Public Member Functions inherited from Waitable
bool | Wait (unsigned long milliseconds, CallStack const &callStack)
| Wait on this object. More...

## Additional Inherited Members

Static Public Attributes inherited from BufferedTransformation
static const std::string & | NULL_CHANNEL = DEFAULT_CHANNEL

## Detailed Description

### template<class T>
class SourceTemplate< T >

Transform a Store into a Source.

String-based implementation of the Source interface.

Template Parameters

  T | the class or type

Definition at line 1223 of file filters.h.

## Constructor & Destructor Documentation

## SourceTemplate()

template<class T>

SourceTemplate< T >::SourceTemplate | ( | BufferedTransformation * | attachment | ) |

inline

Construct a SourceTemplate.

Template Parameters

  T | the class or type

Parameters

  attachment | an attached transformation

Definition at line 1229 of file filters.h.

## Member Function Documentation

## IsolatedInitialize()

template<class T>

void SourceTemplate< T >::IsolatedInitialize | ( | const NameValuePairs & | parameters | ) |

inline virtual

Initialize or reinitialize this object, without signal propagation.

Parameters

  parameters | a set of NameValuePairs to initialize this object

Exceptions

  NotImplemented |

IsolatedInitialize() is used to initialize or reinitialize an object using a variable number of arbitrarily typed arguments. The function avoids the need for multiple constuctors providing all possible combintations of configurable parameters.

IsolatedInitialize() does not call Initialize() on attached transformations. If initialization should be propagated, then use the Initialize() function.

If a derived class does not override IsolatedInitialize(), then the base class throws NotImplemented.

Reimplemented from BufferedTransformation.

Definition at line 1231 of file filters.h.

## Pump2()

template<class T>

size_t SourceTemplate< T >::Pump2 | ( | lword & | byteCount,
|  | bool | blocking = `true`
| ) |  |

inline virtual

Pump data to attached transformation.

Parameters

  byteCount | the maximpum number of bytes to pump
  blocking | specifies whether the object should block when processing input

Returns
  the number of bytes that remain in the block (i.e., bytes not processed)

byteCount is an IN and OUT parameter. When the call is made, byteCount is the requested size of the pump. When the call returns, byteCount is the number of bytes that were pumped.

Implements Source.

Definition at line 1233 of file filters.h.

## PumpMessages2()

template<class T>

size_t SourceTemplate< T >::PumpMessages2 | ( | unsigned int & | messageCount,
|  | bool | blocking = `true`
| ) |  |

inline virtual

Pump messages to attached transformation.

Parameters

  messageCount | the maximpum number of messages to pump
  blocking | specifies whether the object should block when processing input

messageCount is an IN and OUT parameter.

Implements Source.

Definition at line 1235 of file filters.h.

## PumpAll2()

template<class T>

size_t SourceTemplate< T >::PumpAll2 | ( | bool | blocking = `true` | ) |

inline virtual

Pump all data to attached transformation.

Parameters

  blocking | specifies whether the object should block when processing input

Returns
  the number of bytes that remain in the block (i.e., bytes not processed)

Reimplemented from Source.

Definition at line 1237 of file filters.h.

## SourceExhausted()

template<class T>

bool SourceTemplate< T >::SourceExhausted | ( |  | ) | const

inline virtual

Determines if the Source is exhausted.

Returns
  true if the source has been exhausted

Implements Source.

Definition at line 1239 of file filters.h.

## SetAutoSignalPropagation()

template<class T>

void SourceTemplate< T >::SetAutoSignalPropagation | ( | int | propagation | ) |

inline virtual

Set propagation of automatically generated and transferred signals.

Parameters

  propagation | then new value

Setting propagation to `0` means do not automaticly generate signals. Setting propagation to `-1` means unlimited propagation.

Reimplemented from BufferedTransformation.

Definition at line 1241 of file filters.h.

## GetAutoSignalPropagation()

template<class T>

int SourceTemplate< T >::GetAutoSignalPropagation | ( |  | ) | const

inline virtual

Retrieve automatic signal propagation value.

Returns
  the number of attached transformations the signal is propogated to. 0 indicates the signal is only witnessed by this object

Reimplemented from BufferedTransformation.

Definition at line 1243 of file filters.h.

The documentation for this class was generated from the following file:

- filters.h